package com.seeyon.apps.exchange.manager;

import com.seeyon.apps.govdoc.constant.GovdocEnum;
import com.seeyon.apps.govdoc.manager.GovdocExchangeManager;
import com.seeyon.apps.govdoc.po.GovdocExchangeDetail;
import com.seeyon.apps.govdoc.po.GovdocExchangeDetailLog;
import com.seeyon.apps.govdoc.po.GovdocExchangeMain;
import com.seeyon.apps.ocip.event.ExchangeDetailEvent;
import com.seeyon.apps.ocip.exchange.log.po.ExchInfoDetail;
import com.seeyon.ctp.common.AbstractSystemInitializer;
import com.seeyon.ctp.event.EventDispatcher;
import com.seeyon.ctp.util.Strings;

import java.util.List;

/**
 * Created by Seeyon on 2019-12-25.
 */
public class ExchangeDetailListener extends AbstractSystemInitializer {
    private GovdocExchangeManager govdocExchangeManager;

    public void setGovdocExchangeManager(GovdocExchangeManager govdocExchangeManager) {
        this.govdocExchangeManager = govdocExchangeManager;
    }

    @Override
    public void initialize() {
        EventDispatcher.register(ExchangeDetailEvent.class, "exchangeDetailListener", "execute", true);
    }

    public void execute(ExchangeDetailEvent event) throws Exception {
        ExchInfoDetail exchInfoDetail = event.getExchInfoDetail();
        if(Strings.isNotBlank(exchInfoDetail.getGroupId()) && Strings.isNotBlank(exchInfoDetail.getReciverAccount()))
        {
            GovdocExchangeMain main = govdocExchangeManager.findBySummaryId(Long.parseLong(exchInfoDetail.getGroupId()), null);
            if(main != null)
            {
                List<GovdocExchangeDetail> exchangeDetalList = govdocExchangeManager.getExchangeDetailByMainIdRecOrgState(main.getId(), Long.parseLong(exchInfoDetail.getReciverAccount()), GovdocEnum.ExchangeDetailStatus.sending.getKey());
                for(GovdocExchangeDetail detail: exchangeDetalList)
                {
                    detail.setStatus(GovdocEnum.ExchangeDetailStatus.waitSend.getKey());
                    govdocExchangeManager.updateDetail(detail);
                    List<GovdocExchangeDetailLog> detailLogList = govdocExchangeManager.findGovdocExchangeDetailLog(detail.getId(), GovdocEnum.ExchangeDetailStatus.sending.getKey());
                    if(detailLogList != null && !detailLogList.isEmpty())
                    {
                        for(GovdocExchangeDetailLog log :detailLogList)
                        {
                            log.setStatus(GovdocEnum.ExchangeDetailStatus.waitSend.getKey());
                            govdocExchangeManager.updateDetailLog(log);
                        }
                    }
                }
            }
        }


    }
}
